classification
Title: android: test_concurrent_futures hangs on armv7
Type: behavior Stage:
Components: Cross-Build, Library (Lib) Versions: Python 3.6
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: Nosy List: Alex.Willmer, bquinlan, xdegaye
Priority: normal Keywords:

Created on 2016-05-03 15:32 by xdegaye, last changed 2016-05-16 15:26 by xdegaye. This issue is now closed.

Messages (4)
msg264740 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-03 15:32
test_concurrent_futures hangs on an android emulator running an armv7 system image (but not on x86) at API level 21. The test suite hangs at:

test_pending_calls_race (test.test_concurrent_futures.ThreadPoolWaitTests) ...

A cause of this problem may be related to the fact that the android arm emulator runs very, very slowly.
msg264757 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-03 19:10
Interestingly, all the tests (issues #26938, #26939, #26940 and #26941) that hang on arm use sys.setswitchinterval() aggressively.
msg265012 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-06 19:43
The strace output, the process is blocked in a futex system call:

root@generic:/ # strace -p 1304
Process 1304 attached
futex(0xb6f24880, FUTEX_WAIT_PRIVATE, 2, NULL
msg265698 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-16 15:26
test_concurrent_futures is not run on Android because "This platform lacks a functioning sem_open implementation", see issue #26924.

Closing as won't fix.
History
Date User Action Args
2016-05-21 07:06:39xdegayelinkissue26865 dependencies
2016-05-16 15:26:54xdegayesetstatus: open -> closed
resolution: wont fix
messages: + msg265698
2016-05-06 19:43:51xdegayesetmessages: + msg265012
2016-05-03 19:10:38xdegayesetmessages: + msg264757
2016-05-03 15:32:10xdegayecreate